require "ISContinue"

AutoCook = {}
AutoCook.Verbose = false

function AutoCook:stopAutoCook()
    if AutoCook.Verbose then print ("AutoCook:stopAutoCook") end
    if self.returnToContainer then
        --implement own returner with target container and error mngt
        self:returnItemsToOriginalContainer()
        --ISCraftingUI.ReturnItemsToOriginalContainer(self.playerObj, self.returnToContainer);--how the hell does he know where it comes from ?
        self.returnToContainer = {};
    end
end

function AutoCook:continue()--coninue name is used by ISContinue
    if AutoCook.Verbose then print ("AutoCook:continue") end
    if self.addAction and self.addAction.baseItem then
        self.baseItem = self.addAction.baseItem;--in cases base item changed during last add action
        if AutoCook.Verbose then print ("AutoCook:continue item switch to "..self.baseItem:getName()) end
    end
    
    local containerList = ISInventoryPaneContextMenu.getContainers(self.playerObj);
    local items = self.recipe:getItemsCanBeUse(self.playerObj, self.baseItem, containerList);--use vanilla to get the list of potential food items

    local usedItem = self:chooseItem(items,self.baseItem);--here is the automat food selection

    if not usedItem then--if there is no more available item stop auto cook
        self:stopAutoCook();
        return
    end
    
    --get source items
    if not self.playerObj:getInventory():contains(usedItem) then -- take the item if it's not in our inventory
        self:addToReturnContainer(usedItem);
        ISTimedActionQueue.add(ISInventoryTransferAction:new(self.playerObj, usedItem, usedItem:getContainer(), self.playerObj:getInventory(), nil));
    end
    if not self.playerObj:getInventory():contains(self.baseItem) then -- take the base item if it's not in our inventory
        ISTimedActionQueue.add(ISInventoryTransferAction:new(self.playerObj, self.baseItem, self.baseItem:getContainer(), self.playerObj:getInventory(), nil));
    end
    
    --add the timed action to cook the add chosenItem to baseItem in recipe.
    self.addAction = ISAddItemInRecipe:new(self.playerObj, self.recipe, self.baseItem, usedItem, (70 - self.playerObj:getPerkLevel(Perks.Cooking)))
    ISTimedActionQueue.add(self.addAction);

    --add instant timed action to call autocook again once addItem is performed
    ISTimedActionQueue.add(ISContinue:new(self, self.playerObj, 1));
end

function AutoCook:addToReturnContainer(item)
    if item then
        local toReturnStruct = {}
        toReturnStruct.usedItem = item;
        toReturnStruct.sourceContainer = item:getContainer();
        if AutoCook.Verbose then print ("AutoCook:addToReturnContainer "..item:getName().." "..tostring(item)) end
        table.insert(self.returnToContainer, toReturnStruct);
    end
end
function AutoCook:returnItemsToOriginalContainer()
    for _,toReturnStruct in pairs(self.returnToContainer) do
        if AutoCook.Verbose then print ("AutoCook:returnItemsToOriginalContainer "..tostring(toReturnStruct.usedItem and toReturnStruct.usedItem:getName() or "nil").." "..tostring(toReturnStruct.usedItem)) end
        if AutoCook.Verbose then print ("AutoCook:returnItemsToOriginalContainer "..tostring(toReturnStruct.sourceContainer and toReturnStruct.sourceContainer:getType() or "nil").." "..tostring(toReturnStruct.sourceContainer)) end
        if toReturnStruct.usedItem and toReturnStruct.sourceContainer and toReturnStruct.sourceContainer ~= self.playerObj:getInventory() and self.playerObj:getInventory():contains(toReturnStruct.usedItem) then
            local action = ISInventoryTransferAction:new(self.playerObj, toReturnStruct.usedItem, self.playerObj:getInventory(), toReturnStruct.sourceContainer, nil)
            ISTimedActionQueue.add(action)
        end
    end
end
function AutoCook:chooseItem(items,baseItem)
    if AutoCook.Verbose then print ("AutoCook:chooseItem "..baseItem:getName()) end
    if not items or items:size() == 0 then--if there is no more available items stop auto cook
        return nil
    end

    
--take the one that will become rotten the fastest ?
--take the one that gives most nutrition ?
--take the one that gives most happiness ?
    local evoItem = nil
    local listItemsNotAlreadyUsed = {}
    local listItemsUsedOnce = {}
    for i=1,items:size() do
        local item = items:get(i-1);
        if instanceof(item, "Food") then--do we risk to apply also survivor / carpentry / .. recipes ?
            local itemName= item:getFullType()
            local num = self:getNumberAlreadyUsed(itemName);
            if num == 0 then
                table.insert(listItemsNotAlreadyUsed, item);--TODO add nutrition, freshness
            elseif num == 1 then
                table.insert(listItemsUsedOnce, item);
            end
        end
    end
    
    --we switch ingredient as much as possible (highest priority than freshness)
    local chosenList = nil
    if #listItemsNotAlreadyUsed > 0 then
        chosenList = listItemsNotAlreadyUsed
    elseif #listItemsUsedOnce > 0 then
        chosenList = listItemsUsedOnce
    end
    
    
    if chosenList then
        evoItem = chosenList[1] 
        local age = evoItem:getAge();
        local agingDelta = evoItem:getOffAge() - age;
        local rottingDelta = evoItem:getOffAgeMax() - age;
        
        for i=2,#chosenList do
            local item = chosenList[i];
            local newAge = item:getAge();
            local newAgingDelta = item:getOffAge() - newAge;
            local newRottingDelta = item:getOffAgeMax() - newAge;
            --we take the ingredient that is the closest to loose freshness
            --if both have lost freshness we take the ingredient that's the closest to rot
            if newAgingDelta > 0 and (newAgingDelta < agingDelta or agingDelta < 0) or (agingDelta < 0 and newRottingDelta > 0 and (newRottingDelta < rottingDelta or rottingDelta < 0 )) then
                evoItem = item;
                agingDelta = newAgingDelta;
                rottingDelta = newRottingDelta;
            end
        end
    end
        
    if evoItem then
        self:setItemUsed(evoItem:getFullType());
    end
    
    return evoItem
end

function AutoCook:getNumberAlreadyUsed(itemName)
    for i=1,#self.usedItems do
        if self.usedItems[i].itemName == itemName then
            return self.usedItems[i].number;
        end
    end
    return 0
end
function AutoCook:setItemUsed(itemName)
    for i=1,#self.usedItems do
        if self.usedItems[i].itemName == itemName then
            self.usedItems[i].number = self.usedItems[i].number + 1;
            return
        end
    end
    local usedItemStruct = {}
    usedItemStruct.itemName = itemName
    usedItemStruct.number = 1
    table.insert(self.usedItems,usedItemStruct)
end

function AutoCook:new(playerObj, recipe, baseItem)
    if AutoCook.Verbose then print ("AutoCook:new "..recipe:getUntranslatedName()) end
    local o = {}
    setmetatable(o, self)
    self.__index = self
    o.playerObj = playerObj;
    o.recipe = recipe;
    o.baseItem = baseItem;
    o.addAction = nil;
    o.returnToContainer = {};
    
    o.usedItems = {};
    
    return o;
end
